'use strict';

var ListaImagemController = angular.module('ListaImagemController', []);

ListaImagemController.controller('ListaImagemCtrl', ['$scope', '$filter', '$routeParams', 'Construcao', 'UploadApp', 'CacheApp',
  ($scope, $filter, $routeParams, Construcao, UploadApp, CacheApp) => {

    $scope.excluirImagem = (imagem) => {
        $scope.msgBoxPergunta('Imagem da ' + $scope.construcao.TipoDescricao, 'Confirma exclusão da imagem?'
            , () => {
                Construcao.delImagemConstrucao(imagem.Id,
                    (data) => {
                        $scope.updatelist();
                    });
            }
            , () => {
            });
    }

    $scope.blocoDeImagens = () => {
        $scope.exibirDropZone = true;
        document.querySelectorAll(".drop-zone__input").forEach((inputElement) => {
            const dropZoneElement = inputElement.closest(".drop-zone");

            dropZoneElement.addEventListener("click", (e) => {
                inputElement.click();
            });

            inputElement.addEventListener("change", (e) => {
                if (inputElement.files.length) {
                    const totImagens = inputElement.files.length;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.imagens.some(c => c.file == files[i]))
                            continue;
                        $scope.adicionarImagem(files[i]);
                    }
                    $scope.saveImages = true;
                    $scope.$apply();
                }
            });

            dropZoneElement.addEventListener("dragover", (e) => {
                e.preventDefault();
                dropZoneElement.classList.add("drop-zone--over");
            });

            ["dragleave", "dragend"].forEach((type) => {
                dropZoneElement.addEventListener(type, (e) => {
                    dropZoneElement.classList.remove("drop-zone--over");
                });
            });

            dropZoneElement.addEventListener("drop", (e) => {
                e.preventDefault();

                if (e.dataTransfer.files.length) {
                    var files = e.dataTransfer.files;
                    const totImagens = files.length;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.imagens.some(c => c.file == files[i]))
                            continue;
                        $scope.adicionarImagem(files[i]);
                    }
                    $scope.saveImages = true;
                    $scope.$apply();
                }

                dropZoneElement.classList.remove("drop-zone--over");
            });
        }); 
    };

    $scope.adicionarImagem = (files) => {
        var idCount = $scope.imagens.length;

        var imagem = {
            Novo: true,
            Id: 0,
            IdConstrucao: $scope.construcao.Id,
            IdEtapa: '',
            Descricao: '',
            DataImg: CacheApp.getData($filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z')),
            IdCount: idCount,
            file: files
        }

        var reader = new FileReader();
        reader.onload = function(event) {
            imagem.File =  event.target.result;
            $scope.exibirDropZone = false;
            $scope.$apply();
        }
        reader.readAsDataURL(files);

        $scope.imagens.unshift(imagem);
    }

    $scope.cancelaImagem = (imagem) => {
        var idx = $scope.imagens.indexOf(imagem)
        $scope.imagens.splice(idx, 1);

        if ($scope.imagens.filter(i => i.Novo).length == 0)
            $scope.saveImages = false;

        if ($scope.imagens.length == 0) {
            $scope.exibirDropZone = true;
            $scope.saveImages = false;
        }
    }


    $scope.salvarImagem = (imagem) => {
        if (imagem.File) {
            imagem.progress = 0;
            imagem.Data = $filter("date")(imagem.DataImg, 'yyyy-MM-ddT00:00:00Z')
            UploadApp.UploadImagemConstrucao(imagem,
                (progress) => {
                    imagem.progress = progress;
                },
                (result) => {
                    imagem.progress = null;
                    imagem.Novo = false;
                    $scope.saveImages = false;
                    $scope.updatelist();
                },
                (error) => {}
            );
        }
    }

    $scope.getImagensConstrucao = () => {
        Construcao.getImagensConstrucao($scope.construcao.Id,
            (data) => {
                $scope.imagens = data.Instance;
                $scope.imagens.forEach(i => {
                    // var dataHora = CacheApp.getData($filter("date")(i.Data, 'yyyy-MM-ddT00:00:00Z'));
                    // i.Data = new Date(dataHora.getTime() + (24 * (60 * 60 * 1000)));
                    i.Data = CacheApp.getData($filter("date")(i.Data, 'yyyy-MM-ddT06:10:00Z'))
                    i.Novo = false;
                });

                setTimeout(()=>{
                    $("a.fancybox").fancybox({});
                },100);

                $scope.exibirDropZone = false;
            });
    }

    $scope.getEtapasConstrucao = () => {
        $scope.etapas = [];
        Construcao.getEtapasConstrucao($scope.construcao.Id,
            (data) => {
                $scope.etapas = data.Instance;
            });
    }

    $scope.updatelist = () => {
        Construcao.getImagensConstrucao($scope.construcao.Id,
            (data) => {
                $scope.imagens = $scope.imagens.filter(i => i.Novo);

                if ($scope.imagens.length == 0)
                    $scope.saveImages = false;

                data.Instance.forEach(i => {
                    var dataHora = CacheApp.getData($filter("date")(i.Data, 'yyyy-MM-ddT00:00:00Z'));
                    i.Data = new Date(dataHora.getTime() + (24 * (60 * 60 * 1000)));
                    i.Novo = false;
                    $scope.imagens.push(i);
                });

                setTimeout(()=>{
                    $("a.fancybox").fancybox({});
                },100);

                if ($scope.imagens.length == 0)
                    $scope.blocoDeImagens();

            });
    }

    $scope.setListaImagens = () => {
        function salvaImg(imagem, callBackFunction) {
            if (imagem.File) {
                imagem.progress = 0;
                imagem.Data = $filter("date")(imagem.DataImg, 'yyyy-MM-ddT00:00:00Z')
                UploadApp.UploadImagemConstrucao(imagem,
                    (progress) => {
                        imagem.progress = progress;
                    },
                    (result) => {
                        imagem.progress = null;
                        callBackFunction();
                    },
                    (error) => {}
                );
            }
        }

        function salvaImgRecursivo(idx,imgs) {
            if (imgs.length == idx)
                $scope.getImagensConstrucao();
            else {
                salvaImg(imgs[idx], () => {
                    salvaImgRecursivo(idx+1,imgs);
                });
            }
        }

        salvaImgRecursivo(0,$scope.imagens.filter(i => i.Novo));
    }

    $scope.getListaConstrucao = (callBack) => {
        var params = {
            permissao: ($scope.sessao.TipoPlano == 1 || $scope.sessao.ContaAdmin) ? undefined : 'GET_IMAGEM',
            refresh: $scope.refreshObra ? true: false
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.construcoes = obra
                callBack()
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.imagens = [];
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.imagens = [];
        $scope.construcao = obra;
        CacheApp.setConstrucao($scope.construcao);
        $scope.HtmlManterObra = undefined

        $scope.listaRelatorio = [];
        $scope.listaRelatorio = $scope.reportList.filter(r => obra.Acessos.indexOf(r.Permissao) >= 0);

        $scope.getImagensConstrucao();
        $scope.getEtapasConstrucao();
}

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
        if (!$scope.openObra && $scope.construcao.Novo)
            $scope.loadObra()
    }

    $scope.adicionarObra = () => {
        if ($scope.sessao.TipoPlano == 3 && $scope.construcoes && $scope.construcoes.length > 2) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.construcao = { Tipo: 0, Dono: true, Novo: true }
        $scope.editarObra()
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true;
        $scope.loadObra()
    })

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.ObraSelecionada = $scope.construcoes.filter(c => c.Id == $scope.ObraSelecionada.Id)[0]
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }
                $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else {
                $scope.ObraSelecionada = undefined
                $scope.construcao = undefined
                $scope.imagens = []
            }
        })
    }

    $scope.loadPage = () => {
        $scope.reportList = [
            { Id: 0, Descricao: 'Relatório Fotográfico', Permissao: 'GET_RELATORIOFOTOGRAFICO', Url: 'relatoriofotografico' }
        ];
    
        if ($routeParams.from == 'geral') {
            $scope.loadObra()
        } else {
            $scope.construcao = CacheApp.getConstrucao();
            $scope.listaRelatorio = $scope.reportList;
            $scope.imagens = [];
            $scope.getImagensConstrucao();
            $scope.getEtapasConstrucao();
        }
    }

    $scope.sessao = CacheApp.getSessao()
    $scope.loadPage()

  }]);
